package com.example.skt

import com.skt.Tmap.TMapPoint

class CameraPosition private constructor(builder: Builder) {
    var tmapPoint: TMapPoint
    var zoom: Int = 0

    class Builder {
        var tmapPoint: TMapPoint? = null
        var zoom: Int = 0

        fun target(target: TMapPoint): Builder {
            this.tmapPoint = target
            return this
        }

        fun zoom(zoom: Int): Builder {
            this.zoom = zoom
            return this
        }

        fun build(): CameraPosition {
            return CameraPosition(this)
        }
    }

    init {
        tmapPoint = builder.tmapPoint!!
        zoom = builder.zoom
    }

    companion object {

        fun builder(): Builder {
            return CameraPosition.Builder()
        }
    }
}
