package com.example.skt

import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.graphics.Point
import android.util.Log

import io.flutter.view.FlutterMain
import com.example.skt.CameraPosition.Builder

import java.util.ArrayList
import java.util.Arrays
import java.util.HashMap
import com.skt.Tmap.TMapPoint

internal object Convert {

    fun toCameraPosition(o: Any): CameraPosition {
        val builder = CameraPosition.builder()
        val data = toMap(o)
        builder.target(toTMapPoint(data.get("target")!!))
        builder.zoom(toInt(data.get("zoom")!!))
        return builder.build()
    }

    private fun toDouble(o: Any): Double {
        return (o as Number).toDouble()
    }

    private fun toFloat(o: Any): Float {
        return (o as Number).toFloat()
    }

    private fun toFloatWrapper(o: Any?): Float? {
        return if (o == null) null else toFloat(o)
    }

    private fun toInt(o: Any): Int {
        return (o as Number).toInt()
    }

    private fun toMap(o: Any): Map<*, *> {
        return o as Map<*, *>
    }

    private fun toTMapPoint(o: Any): TMapPoint {
        val data = toList(o)
        return TMapPoint(toDouble(data[0]!!), toDouble(data[1]!!))
    }

    private fun toList(o: Any): List<*> {
        return o as List<*>
    }

    fun cameraPositionToJson(position: CameraPosition?): Any? {
        if (position == null) {
            return null
        }
        val data = HashMap<String, Any>()
        data["target"] = tMapPointToJson(position.tmapPoint)
        data["zoom"] = position.zoom
        return data
    }

    fun tMapPointToJson(tmapPoint: TMapPoint): Any {
        return Arrays.asList<Any>(tmapPoint.latitude, tmapPoint.longitude)
    }
}
