// Copyright 2018 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

package com.example.skt

import android.content.Context
import io.flutter.plugin.common.PluginRegistry
import java.util.concurrent.atomic.AtomicInteger
import android.util.Log

import com.skt.Tmap.TMapPoint

internal class TMapBuilder : TMapOptionsSink {
    /*
  private final GoogleMapOptions options = new GoogleMapOptions();
  private boolean trackCameraPosition = false;
  private boolean myLocationEnabled = false;
  private boolean myLocationButtonEnabled = false;*/
    private val options = TMapOptions()
    private var initialMarkers: Any? = null
    private var initialPolylines: Any? = null
    private var initialCircles: Any? = null

    fun build(
            id: Int, context: Context, state: AtomicInteger, registrar: PluginRegistry.Registrar): TMapController {
        val controller = TMapController(id, context, state, registrar, options)
        controller.init()
        //controller.setMyLocationEnabled(myLocationEnabled);
        //controller.setMyLocationButtonEnabled(myLocationButtonEnabled);
        //controller.setTrackCameraPosition(trackCameraPosition);
        //controller.setInitialMarkers(initialMarkers);
        //controller.setInitialPolylines(initialPolylines);
        //controller.setInitialCircles(initialCircles);
        return controller
    }

    fun setInitialCameraPosition(position: CameraPosition) {
        options.camera(position)
    }

    override fun setCompassEnabled(compassEnabled: Boolean) {
        //options.compassEnabled(compassEnabled);
    }

    override fun setCameraTargetBounds(bounds: Any) {
        //options.latLngBoundsForCameraTarget(bounds);
    }

    override fun setMinMaxZoomPreference(min: Float?, max: Float?) {
        if (min != null) {
            //options.minZoomPreference(min);
        }
        if (max != null) {
            //options.maxZoomPreference(max);
        }
    }

    override fun setRotateGesturesEnabled(rotateGesturesEnabled: Boolean) {
        //options.rotateGesturesEnabled(rotateGesturesEnabled);
    }

    override fun setScrollGesturesEnabled(scrollGesturesEnabled: Boolean) {
        //options.scrollGesturesEnabled(scrollGesturesEnabled);
    }

    override fun setZoomGesturesEnabled(zoomGesturesEnabled: Boolean) {
        //options.zoomGesturesEnabled(zoomGesturesEnabled);
    }

    override fun setInitialMarkers(initialMarkers: Any) {
        this.initialMarkers = initialMarkers
    }

    override fun setInitialPolylines(initialPolylines: Any) {
        this.initialPolylines = initialPolylines
    }

    override fun setInitialCircles(initialCircles: Any) {
        this.initialCircles = initialCircles
    }
}
