package com.example.skt

import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.graphics.Bitmap
import android.app.Activity
import android.content.pm.PackageManager
import android.os.Bundle
import android.net.Uri
import android.view.View
import android.webkit.WebView
import android.webkit.WebViewClient
import android.app.Application
import android.content.pm.ApplicationInfo
import io.flutter.plugin.common.EventChannel
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.platform.PlatformView

import com.skt.Tmap.BizCategory
import com.skt.Tmap.TMapCircle
import com.skt.Tmap.TMapData
import com.skt.Tmap.TMapPOIItem
import com.skt.Tmap.TMapData.BizCategoryListenerCallback
import com.skt.Tmap.TMapData.ConvertGPSToAddressListenerCallback
import com.skt.Tmap.TMapData.FindAllPOIListenerCallback
import com.skt.Tmap.TMapData.FindAroundNamePOIListenerCallback
import com.skt.Tmap.TMapData.FindPathDataAllListenerCallback
import com.skt.Tmap.TMapData.FindPathDataListenerCallback
import com.skt.Tmap.TMapData.TMapPathType
import com.skt.Tmap.TMapGpsManager
import com.skt.Tmap.TMapGpsManager.onLocationChangedCallback
import com.skt.Tmap.TMapInfo
import com.skt.Tmap.TMapLabelInfo
import com.skt.Tmap.TMapMarkerItem
import com.skt.Tmap.TMapMarkerItem2
import com.skt.Tmap.TMapPoint
import com.skt.Tmap.TMapPolyLine
import com.skt.Tmap.TMapPolygon
import com.skt.Tmap.TMapTapi
import com.skt.Tmap.TMapView
import java.util.concurrent.atomic.AtomicInteger

import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import android.util.Log


internal class TMapController(private val id: Int, var context: Context, private val activityState: AtomicInteger, private val registrar: PluginRegistry.Registrar, private val options: TMapOptions) : PlatformView, MethodCallHandler, Application.ActivityLifecycleCallbacks {
    var webView: View
    var url = ""
    var channel: MethodChannel
    //var tMapView: TMapView?=null

    init {
        this.url = url
        webView = getWebView(registrar, this.options)

        channel = MethodChannel(registrar.messenger(), "SKTMap_$id")

        channel.setMethodCallHandler(this)
    }

    override fun getView(): View {
        return webView
    }

    fun init() {
        registrar.activity().getApplication().registerActivityLifecycleCallbacks(this)
    }

    override fun dispose() {

    }

    override fun onActivityCreated(activity: Activity, savedInstanceState: Bundle) {}

    override fun onActivityStarted(activity: Activity) {}

    override fun onActivityResumed(activity: Activity) {}

    override fun onActivityPaused(activity: Activity) {}

    override fun onActivityStopped(activity: Activity) {}

    override fun onActivitySaveInstanceState(activity: Activity, outState: Bundle) {}

    override fun onActivityDestroyed(activity: Activity) {}

    private fun getWebView(registrar: PluginRegistry.Registrar, options: TMapOptions): View {
        var tMapView = TMapView(this.context)
        tMapView.setHttpsMode(true)

        var appInfo = this.context.getPackageManager().getApplicationInfo(this.context.packageName, PackageManager.GET_META_DATA)
        var aBundle = appInfo.metaData
        var aValue = aBundle.getString("com.skt.android.geo.API_KEY")
        tMapView.setSKTMapApiKey(aValue)
        tMapView.setCenterPoint(options.cameraPosition!!.tmapPoint!!.longitude, options.cameraPosition!!.tmapPoint!!.latitude)
        tMapView.zoomLevel = options.cameraPosition!!.zoom
        return tMapView
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        if (call.method == "MapView") {
            result.success(Convert.cameraPositionToJson(options.cameraPosition))
        } else if(call.method == "Circle"){

        } else if(call.method == "Marker"){

        } else {
            result.notImplemented()
        }
    }
}
