package com.example.skt

import android.content.Context
import android.util.Log

import io.flutter.plugin.common.StandardMessageCodec
import io.flutter.plugin.platform.PlatformView
import io.flutter.plugin.platform.PlatformViewFactory
import java.util.concurrent.atomic.AtomicInteger

import io.flutter.plugin.common.PluginRegistry.Registrar

class TMapFactory(private val mActivityState: AtomicInteger, private val mPluginRegistrar: Registrar) : PlatformViewFactory(StandardMessageCodec.INSTANCE) {

    override fun create(context: Context, id: Int, args: Any): PlatformView {
        val params = args as Map<String, Any>

        val builder = TMapBuilder()
        if (params.containsKey("initialCameraPosition")) {
            val position = Convert.toCameraPosition(params["initialCameraPosition"]!!)
            builder.setInitialCameraPosition(position)
        }
        return builder.build(id, context, mActivityState, mPluginRegistrar)
    }
}
