

part of skt_maps_flutter;

typedef void WebViewCreatedCallback(WebController controller);

class SKTMap extends StatefulWidget {

  const SKTMap({
    Key key,
    @required this.initialCameraPosition,
    this.onWebCreated,
    this.gestureRecognizers,
  }):   assert(initialCameraPosition != null),
        super(key: key);

  final Set<Factory<OneSequenceGestureRecognizer>> gestureRecognizers;
  final CameraPosition initialCameraPosition;
  final WebViewCreatedCallback onWebCreated;

  @override
  State createState() => _SKTMapState();
}

class _SKTMapState extends State<SKTMap> {

  final Completer<WebController> _controller =
  Completer<WebController>();


  @override
  Widget build(BuildContext context) {
    final Map<String, dynamic> creationParams = <String, dynamic>{
      'initialCameraPosition': widget.initialCameraPosition?._toMap(),
    };
    if(defaultTargetPlatform == TargetPlatform.android) {
      return AndroidView(
        viewType: 'SKTMap',
        onPlatformViewCreated: onPlatformViewCreated,
        gestureRecognizers: widget.gestureRecognizers,
        creationParams: creationParams,
        creationParamsCodec: const StandardMessageCodec(),
      );
    } else if(defaultTargetPlatform == TargetPlatform.iOS) {
      return UiKitView(
        viewType: 'SKTMap',
        onPlatformViewCreated: onPlatformViewCreated,
        gestureRecognizers: widget.gestureRecognizers,
        creationParams: creationParams,
        creationParamsCodec: const StandardMessageCodec(),
      );
    }

    return new Text('$defaultTargetPlatform is not yet supported by this plugin');
  }

  @override
  void initState() {
    super.initState();
//    _googleMapOptions = _GoogleMapOptions.fromWidget(widget);
//    _markers = _keyByMarkerId(widget.markers);
//    _polylines = _keyByPolylineId(widget.polylines);
//    _circles = _keyByCircleId(widget.circles);
  }



  Future<void> onPlatformViewCreated(int id) async {

    final WebController controller = await WebController.init(
      id,
      widget.initialCameraPosition,
      this,
    );
    _controller.complete(controller);
    if (widget.onWebCreated != null) {
      widget.onWebCreated(controller);
    }


//    if (widget.onWebCreated == null) {
//      return;
//    }
//    widget.onWebCreated(new WebController.init(id));
  }

}


