#!/bin/bash -e

# generate_coverage.sh
# What does it do?
# It generates an lcov.info and coverage report in ./coverage.
# Works for both flutter and dart packages
#
# How to use:
# sh generate_coverage.sh

DIR=${1-'.'}

cd $DIR
rm -rf coverage
if grep -q 'sdk: flutter' "./pubspec.yaml"; then
	flutter packages get
	flutter test --coverage
else
	pub get
	pub run test_coverage
fi

lcov --remove ./coverage/lcov.info '**/main.dart' -o coverage/lcov.info

genhtml coverage/lcov.info --output=coverage
