
import 'dart:typed_data';

import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:skt/skt.dart';

class FakePlatformSktMap{

  FakePlatformSktMap(int id, Map<dynamic, dynamic> params) {
    cameraPosition = CameraPosition.fromMap(params['initialCameraPosition']);
    channel = MethodChannel(
        'SKTMap_$id', const StandardMethodCodec());
    channel.setMockMethodCallHandler(onMethodCall);
//    updateOptions(params['options']);
//    updateMarkers(params);
//    updatePolylines(params);
//    updateCircles(params);
  }


  MethodChannel channel;

  CameraPosition cameraPosition;

  Future<dynamic> onMethodCall(MethodCall call) {
    switch (call.method) {
      case 'map#update':
//        updateOptions(call.arguments['options']);
        return Future<void>.sync(() {});
      case 'markers#update':
//        updateMarkers(call.arguments);
        return Future<void>.sync(() {});
      case 'polylines#update':
//        updatePolylines(call.arguments);
        return Future<void>.sync(() {});
      case 'circles#update':
//        updateCircles(call.arguments);
        return Future<void>.sync(() {});
      default:
        return Future<void>.sync(() {});
    }
  }
}

class FakePlatformViewsController {
  FakePlatformSktMap lastCreatedView;

  Future<dynamic> fakePlatformViewsMethodHandler(MethodCall call) {
    switch (call.method) {
      case 'create':
        final Map<dynamic, dynamic> args = call.arguments;
        final Map<dynamic, dynamic> params = _decodeParams(args['params']);
        lastCreatedView = FakePlatformSktMap(
          args['id'],
          params,
        );
        return Future<int>.sync(() => 1);
      default:
        return Future<void>.sync(() {});
    }
  }

  void reset() {
    lastCreatedView = null;
  }
}

Map<dynamic, dynamic> _decodeParams(Uint8List paramsMessage) {
  final ByteBuffer buffer = paramsMessage.buffer;
  final ByteData messageBytes = buffer.asByteData(
    paramsMessage.offsetInBytes,
    paramsMessage.lengthInBytes,
  );
  return const StandardMessageCodec().decodeMessage(messageBytes);
}
