import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:skt/skt.dart';

import 'fake_maps_controllers.dart';

void main() {

  final FakePlatformViewsController fakePlatformViewsController =
  FakePlatformViewsController();

  setUpAll(() {
    SystemChannels.platform_views.setMockMethodCallHandler(
        fakePlatformViewsController.fakePlatformViewsMethodHandler);
  });

  setUp(() {
    fakePlatformViewsController.reset();
  });


//  testWidgets('test', (WidgetTester test) async {
//
//    final test = "123";
//    expect(test, "123");
//  });

  testWidgets('Initial camera position', (WidgetTester tester) async {
    await tester.pumpWidget(
      const Directionality(
        textDirection: TextDirection.ltr,
        child: SKTMap(
          initialCameraPosition: CameraPosition(target: LatLng(37.566474, 126.985022)),
        ),
      ),
    );

    final FakePlatformSktMap platformGoogleMap =
        fakePlatformViewsController.lastCreatedView;

    expect(platformGoogleMap.cameraPosition,
        const CameraPosition(target: LatLng(37.566474, 126.985022)));

  });
}

